<template>
  <main>
    <section class="section">
      <div class="header-leaderboard">
        <InstanceButton
          :title="$t('pages.leaderboard.all_instance')"
          name="all"
          image="logo.jpg"
          :is-active="selectedInstances.length > 1"
          @trigger="triggerInstance"
        />
        <InstanceButton
          v-for="instance in instancesList"
          :is-active="
            selectedInstances.length === 1 &&
            selectedInstances[0] === instance.name
          "
          :title="instance.name"
          :name="instance.name"
          :image="instance.logo"
          @trigger="triggerInstance"
        />
      </div>
      <div class="entry-leaderboard">
        <div class="leaderboard">
          <div class="switch-label">
            <span>{{ $t('pages.leaderboard.period_title') }}</span>
          </div>
          <form class="wrapper-switch">
            <InputRadio
              :title="$t('pages.leaderboard.period_full')"
              name="periodAll"
              id="all"
              image="full-days-blue-dark.svg"
              image-selected="full-days-blue.svg"
              :is-checked="selectedPeriod === 'all'"
              @trigger="triggerPeriod"
            />
            <InputRadio
              :title="$t('pages.leaderboard.period_30')"
              name="period30"
              id="last_30_days"
              image="30-days-blue-dark.svg"
              image-selected="30-days-blue.svg"
              :is-checked="selectedPeriod === 'last_30_days'"
              @trigger="triggerPeriod"
            />
            <InputRadio
              :title="$t('pages.leaderboard.period_7')"
              name="period7"
              id="last_7_days"
              image="7-days-blue-dark.svg"
              image-selected="7-days-blue.svg"
              :is-checked="selectedPeriod === 'last_7_days'"
              @trigger="triggerPeriod"
            />
          </form>
          <Leaderboard
            v-if="dataStatsByContributors?.length"
            :stats-by-contributors="dataStatsByContributors"
          />
        </div>
        <ListLeaderboard
          v-if="dataStatsByContributors?.length"
          :stats-by-contributors="dataStatsByContributors"
        />
      </div>
    </section>
  </main>
</template>

<script lang="ts" setup>
import { ref, onMounted } from 'vue'
import InstanceButton from '@/components/InstanceButton.vue'
import ListLeaderboard from '@/components/ListLeaderboard.vue'
import InputRadio from '@/components/InputRadio.vue'
import Leaderboard from '@/components/Leaderboard.vue'
import { formatInstanceList } from '@/utils'
import type { StatsByContributor } from '@/interfaces/leaderboard'
const instancesList = ref<{ name: string; color: string; logo: string }[]>([])
const selectedPeriod = ref<string>('all')
const selectedInstances = ref<string[]>([])
const dataStatsByContributors = ref<StatsByContributor[]>([])

onMounted(async () => {
  await fetchContributors()
  dataStatsByContributors.value = dataStatsByContributors.value.sort(
    (a: StatsByContributor, b: StatsByContributor) => b.nb_items - a.nb_items
  )
  addRankToContributors()
  let listInstance: string[] = dataStatsByContributors.value.map(
    (e) => e.instance_name
  )
  listInstance = listInstance.filter((element, index) => {
    return listInstance.indexOf(element) === index
  })
  instancesList.value = formatInstanceList(listInstance)
  selectedInstances.value = instancesList.value.map((e) => e.name)
})

async function triggerInstance(value: string) {
  if (value !== 'all') selectedInstances.value = [value]
  else selectedInstances.value = ['osm-fr', 'ign', 'mapcomplete']
  await filterContributors()
}
async function triggerPeriod(value: string) {
  selectedPeriod.value = value
  await filterContributors()
}
async function filterContributors() {
  await fetchContributors()
  if (selectedPeriod.value !== 'all') filterByPeriod()
  filterByInstance()
  dataStatsByContributors.value = sortContributors()
  addRankToContributors()
}
function addRankToContributors() {
  dataStatsByContributors.value = dataStatsByContributors.value.map(
    (e: StatsByContributor, i: number) => {
      return {
        ...e,
        rank: i + 1
      }
    }
  )
}
function sortContributors() {
  return dataStatsByContributors.value.sort(
    (a: StatsByContributor, b: StatsByContributor) => b.nb_items - a.nb_items
  )
}

async function fetchContributors() {
  const api = import.meta.env.VITE_API_URL
  const dataStatsByContributor = await fetch(`${api}stats/by_contributor/`)
  const statsByContributor = await dataStatsByContributor.json()
  dataStatsByContributors.value = statsByContributor.stats_by_contributor
}
function filterByPeriod() {
  dataStatsByContributors.value = dataStatsByContributors.value.map(
    (contributor: any): StatsByContributor => {
      return {
        ...contributor,
        nb_items: contributor?.history[selectedPeriod.value]?.nb_items,
        km_captured: contributor?.history[selectedPeriod.value]?.km_captured
      }
    }
  )
}
function filterByInstance() {
  dataStatsByContributors.value = dataStatsByContributors.value.filter(
    (e: StatsByContributor) => selectedInstances.value.includes(e.instance_name)
  )
}
</script>

<style scoped lang="scss">
.section {
  display: flex;
  padding-right: 4rem;
}
.header-leaderboard {
  border-top: none;
  padding-left: 2rem;
  padding-right: 2rem;
  padding-top: 4rem;
  background-color: var(--blue-pale);
  position: relative;
}
.entry-leaderboard {
  width: 100%;
  padding-left: 4rem;
  padding-top: 4rem;
  padding-bottom: 6rem;
}
.leaderboard {
  width: 100%;
}
.switch-label {
  padding: 2rem 2rem 0;
  font-size: 1.8rem;
  font-weight: bold;
}
.wrapper-switch {
  display: flex;
  width: 100%;
  border-radius: 0.5rem;
  padding: 1rem 2rem 2rem;
}
@media (max-width: 768px) {
  .section {
    padding-right: 0;
    overflow: hidden;
  }
  .entry-leaderboard {
    padding-left: 2rem;
    padding-right: 2rem;
    padding-top: 8rem;
  }
  .header-leaderboard {
    display: flex;
    align-items: center;
    position: absolute;
    padding: 1.5rem;
    overflow-x: auto;
    width: 100%;
    z-index: 1;
    &::-webkit-scrollbar {
      display: none;
    }
  }
  .wrapper-switch {
    padding-right: 0;
    padding-left: 0;
  }
  .switch-label {
    padding-left: 0;
    font-size: 1.6rem;
  }
}
</style>
